#include "load_osnova.h"

/*
 * load_osnova.c
 *
 * Program to populate 'osnova' table of 'MDEBS' database with data from 
 * an ascii file, 'osnova.dat'
 */

void main(void)
{
  char rec1[61];
  char rec2[7];
  char *acctnum;
  char *analnum;
  char *acctDesig;
  int i;

  printf("Opening osnova.dat... ");
  openOSNOVA_DAT();         /* open the BSC5.DAT file */
  printf("Done.\n");

  printf("Initializing the backend... ");
  initBackend(DATABASE);  /* initialize the backend connection */
  printf("Done.\n");

  startTransaction();

  while ((fgets(rec1, 62, fp) != NULL) &&
	 (fgets(rec2, 8, fp) != NULL)) {
    acctDesig = malloc(61);
    for (i = 0; i <= 60; i++) {
      if (rec1[i] == '\n') {
	*(acctDesig+i) = '\0';
	break;
      }
      *(acctDesig+i) = rec1[i];
      if (rec1[i] == '\0') break;
    }
    acctnum = strtok(rec2, " ");
    if (*(acctnum+3) == '\n') *(acctnum+3) = '\0';
    if (strlen(acctnum) != 3) {
      fprintf(stderr, "Fatal error: Supposed account number (%s) not three characters long.\n", acctnum);
      rollbackTransaction();
      finish();
    }
    analnum = strtok(NULL, " ");
    if (analnum == NULL) {
      analnum = "--";
    }
    if (*(analnum+2) == '\n') *(analnum+2) = '\0';
    if (strlen(analnum) != 2) {
      fprintf(stderr, "Fatal error: Supposed analytical account number (%s) not two chars long.\n", analnum);
      rollbackTransaction();
      finish();
    }
    printf("%s %s: %s\n", acctnum, analnum, acctDesig);
    insertAcct(acctnum, analnum, acctDesig);
  }
  endTransaction();
  finish();
}

void insertAcct(char *acct, char *anal, char *acctDesig)
{
  char miscbuff[161];
  int resultcode;

  sprintf(miscbuff, "INSERT INTO osnova VALUES ('%s', '%s', '%s');", acct, anal,
 acctDesig);
  resultcode = runQueryInTrans(miscbuff);
  if (resultcode == 2) {
    printf("Insert command successful.\n");
  } else {
    fprintf(stderr, "Insert command returned (%d), which is not what I expected.\n", resultcode);
    rollbackTransaction();
    finish();
  }
  return;
}

void finish()
{
  closeOSNOVA_DAT();
  exit_nicely();
}

void openOSNOVA_DAT()
{

  if ((fp = fopen(OSNOVA_DAT, "r")) == NULL)
  {
      fprintf(stderr, 
                "Fatal Error: Could not open %s for reading.\n", OSNOVA_DAT);
      exit_nicely();
  }
}

void closeOSNOVA_DAT()
{
  fclose(fp);
  return;
}
